package gz.cyberbrain.cyberhotel.junit.tests.facade.delegate.spring;

import java.util.Calendar;
import java.util.Collection;

import gz.cyberbrain.cyberhotel.junit.tests.facade.delegate.TestFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.bank.dao.BankDao;
import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.board.dao.BoardDao;
import gz.cyberbrain.cyberhotel.model.board.to.BoardTo;
import gz.cyberbrain.cyberhotel.model.card.dao.CardDao;
import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.concept.dao.ConceptDao;
import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.day.dao.DayDao;
import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.employee.dao.EmployeeDao;
import gz.cyberbrain.cyberhotel.model.employee.to.EmployeeTo;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.price.dao.PriceDao;
import gz.cyberbrain.cyberhotel.model.price.to.PriceTo;
import gz.cyberbrain.cyberhotel.model.pricetype.dao.PriceTypeDao;
import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.reservation.dao.ReservationDao;
import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.roomtype.dao.RoomTypeDao;
import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.SpringDaoFactory;
import gz.cyberbrain.cyberhotel.model.user.dao.UserDao;
import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.wash.dao.WashDao;
import gz.cyberbrain.cyberhotel.model.wash.to.WashTo;

public class TestFacadeSpringDelegate implements TestFacadeDelegate {

	private static final long serialVersionUID = 7872036004577605444L;

	public AddressTo findAddress(Long addressId) throws InstanceNotFoundException, InternalErrorException {

		try {

			AddressDao addressDao = SpringDaoFactory.getAddressDao();
			return addressDao.find(addressId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;

		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public BankTo findBank(Long bankId) throws InstanceNotFoundException, InternalErrorException {

		try {

			BankDao bankDao = SpringDaoFactory.getBankDao();
			return bankDao.find(bankId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;		
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public CardTo findCard(Long cardId) throws InstanceNotFoundException, InternalErrorException {

		try {

			CardDao cardDao = SpringDaoFactory.getCardDao();
			return cardDao.find(cardId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public RoomTo findRoom(String roomCode) throws InstanceNotFoundException, InternalErrorException {

		try {

			RoomDao roomDao = SpringDaoFactory.getRoomDao();
			return roomDao.find(roomCode);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public RoomTypeTo findRoomType(String roomTypeCode) throws InstanceNotFoundException, InternalErrorException {

		try {

			RoomTypeDao roomTypeDao = SpringDaoFactory.getRoomTypeDao();
			return roomTypeDao.find(roomTypeCode);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public BoardTo findBoard(String boardCode) throws InstanceNotFoundException, InternalErrorException {

		try {

			BoardDao boardDao = SpringDaoFactory.getBoardDao();
			return boardDao.find(boardCode);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public PriceTypeTo findPriceType(String priceTypeCode) throws InstanceNotFoundException, InternalErrorException {

		try {

			PriceTypeDao priceTypeDao = SpringDaoFactory.getPriceTypeDao();
			return priceTypeDao.find(priceTypeCode);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public SeasonTo findSeason(Long seasonId) throws InstanceNotFoundException, InternalErrorException {

		try {

			SeasonDao seasonDao = SpringDaoFactory.getSeasonDao();
			return seasonDao.find(seasonId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public PriceTo findPrice(Long priceId, String board, String priceType, Long season) 
	throws InstanceNotFoundException, InternalErrorException {

		try {

			PriceDao priceDao = SpringDaoFactory.getPriceDao();
			return priceDao.find(priceId, board, priceType, season);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}


	}

	public ConceptTo findConcept(String conceptCode) throws InstanceNotFoundException, InternalErrorException {

		try {

			ConceptDao conceptDao = SpringDaoFactory.getConceptDao();
			return conceptDao.find(conceptCode);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public DayTo findDay(Calendar dayDate) throws InstanceNotFoundException, InternalErrorException {

		try {

			DayDao dayDao = SpringDaoFactory.getDayDao();
			return dayDao.find(dayDate);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public EmployeeTo findEmployee(Long employeeId) throws InstanceNotFoundException, InternalErrorException {

		try {

			EmployeeDao employeeDao = SpringDaoFactory.getEmployeeDao();
			return employeeDao.find(employeeId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public UserTo findUser(String login) throws InstanceNotFoundException, InternalErrorException {

		try {

			UserDao userDao = SpringDaoFactory.getUserDao();
			return userDao.find(login);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}
	}

	public ClientTo findParticular(Long clientId)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			ClientDao clientDao = SpringDaoFactory.getParticularDao();
			return clientDao.find(clientId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public ClientTo findAgency(Long clientId)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			ClientDao clientDao = SpringDaoFactory.getAgencyDao();
			return clientDao.find(clientId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public ClientTo findCompany(Long clientId)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			ClientDao clientDao = SpringDaoFactory.getCompanyDao();
			return clientDao.find(clientId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public ReservationTo findReservation(Long reservationId)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			ReservationDao reservationDao = SpringDaoFactory.getReservationDao();
			return reservationDao.find(reservationId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

	public Collection reservationRequests(Long reservationId) 
	throws InternalErrorException {

		try {

			ReservationDao reservationDao = SpringDaoFactory.getReservationDao();
			return reservationDao.findRequests(reservationId);

		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}
	}

	public OweTo findOwe(Long reservation, Long oweNumber)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			OweDao oweDao = SpringDaoFactory.getOweDao();
			return oweDao.find(reservation, oweNumber);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}
	
	public WashTo findWash(String roomCode, Long employeeId, Long washId)
	throws InstanceNotFoundException, InternalErrorException {

		try {

			WashDao washDao = SpringDaoFactory.getWashDao();
			return washDao.find(roomCode, employeeId, washId);

		} catch (InstanceNotFoundException e) {
			throw e;
		} catch (InternalErrorException e) {
			throw e;
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}

	}

}
