package gz.cyberbrain.cyberhotel.model.concept.dao;

import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface ConceptDao {

	public ConceptTo create(ConceptTo conceptTo) throws InternalErrorException;

	public ConceptTo find(String conceptCode) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (ConceptTo conceptTo) 
		throws InternalErrorException;
	
	public void remove(ConceptTo conceptTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public boolean existOwes(String conceptCode) throws InternalErrorException;
	
}
