package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.user.dao.UserDao;
import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.encrypt.PasswordEncrypter;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class ChangePasswordAction {

	private String login;
	private String newPassword;
	private UserDao userDao;
	
	public ChangePasswordAction(String login, String newPassword, UserDao userDao) {
		
		this.login = login;
		this.newPassword = PasswordEncrypter.encrypt(newPassword,login);
		this.userDao = userDao;
		
	}
	
	public void execute() throws InstanceNotFoundException, InternalErrorException {
		
		UserTo user = userDao.find(login);
		
		user.setPassword(newPassword);
		userDao.update(user);
		
	}
	
}
