package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableRoomTypeException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.roomtype.dao.RoomTypeDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class CreateRoomAction {

private RoomTo roomTo;
private RoomTypeDao roomTypeDao;
private RoomDao roomDao;
	
	public CreateRoomAction(RoomTo roomTo, RoomTypeDao roomTypeDao, RoomDao roomDao) {
		
		this.roomTo = roomTo;
		this.roomTypeDao = roomTypeDao;
		this.roomDao = roomDao;
		
	}
	
	public RoomTo execute() throws UnaceptableRoomTypeException, InternalErrorException {
		
		try {
			roomTypeDao.find(roomTo.getType());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableRoomTypeException(roomTo.getType());
		}
				
		return roomDao.create(roomTo);
		
	}
	
}
