package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import java.util.Collection;
import java.util.Iterator;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.AddressInUseException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteAddressByCountryAction {

	private String country;
	private AddressDao addressDao;

	public DeleteAddressByCountryAction (String country, AddressDao addressDao) {

		this.country = country;
		this.addressDao = addressDao;

	}

	public void execute() throws AddressInUseException, InternalErrorException {	

		Collection values = addressDao.findByCountry(country);

		Iterator iter = values.iterator();
		AddressTo currentAddress;

		for (int i=0; iter.hasNext(); i++) { 

			currentAddress = (AddressTo) iter.next();
			if (addressDao.existClients(currentAddress.getAddressId(), currentAddress.getCountry())) throw new AddressInUseException(currentAddress); 

		}

		iter = null;
		iter = values.iterator();
		
		for (int i=0; iter.hasNext(); i++) { 

			currentAddress = (AddressTo) iter.next();
			addressDao.remove(currentAddress);		

		}

	}


}
