package gz.cyberbrain.cyberhotel.model.room.dao;

import java.util.Calendar;
import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public interface RoomDao {

	public RoomTo create(RoomTo roomTo) throws InternalErrorException;

	public RoomTo find(String roomCode) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (RoomTo roomTo) 
		throws InternalErrorException;
	
	public void remove(RoomTo roomTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findAllIds() throws InternalErrorException;

	public Collection findByType (String type)
		throws InternalErrorException;
	
	public Collection findByOccupancyStatus (String occupancyStatus) 
		throws InternalErrorException;
	
	public Collection findByCleaningStatus (String cleaningStatus) 
	throws InternalErrorException;
	
	public Collection findByTypeAndOccupancy (String [] attributes)
		throws InternalErrorException;
	
	public boolean existBoarders(String roomCode) throws InternalErrorException;
	
	public Collection freeBetweenDates(Calendar []dates) 
		throws InternalErrorException;
	
	public Long findCurrentCheckIn (String roomCode) throws InternalErrorException;
}
