package gz.cyberbrain.cyberhotel.model.spring.dao;

import javax.sql.DataSource;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.bank.dao.BankDao;
import gz.cyberbrain.cyberhotel.model.board.dao.BoardDao;
import gz.cyberbrain.cyberhotel.model.card.dao.CardDao;
import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.concept.dao.ConceptDao;
import gz.cyberbrain.cyberhotel.model.day.dao.DayDao;
import gz.cyberbrain.cyberhotel.model.employee.dao.EmployeeDao;
import gz.cyberbrain.cyberhotel.model.invoice.dao.InvoiceDao;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.price.dao.PriceDao;
import gz.cyberbrain.cyberhotel.model.pricetype.dao.PriceTypeDao;
import gz.cyberbrain.cyberhotel.model.request.dao.RequestDao;
import gz.cyberbrain.cyberhotel.model.reservation.dao.ReservationDao;
import gz.cyberbrain.cyberhotel.model.role.dao.RoleDao;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.roomtype.dao.RoomTypeDao;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.user.dao.UserDao;
import gz.cyberbrain.cyberhotel.model.wash.dao.WashDao;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SpringDaoFactory {

	private static ApplicationContext context;
	
	static {
		context = new ClassPathXmlApplicationContext("applicationContext.xml");
		}
	
	private SpringDaoFactory(){}
	
	public static DataSource getDataSource() {
		return (DataSource) context.getBean("dataSource");
	}
	
	public static AddressDao getAddressDao() {
		return (AddressDao) context.getBean("addressDao");
	}
	
	public static BankDao getBankDao() {
		return (BankDao) context.getBean("bankDao");
	}
	
	public static CardDao getCardDao() {
		return (CardDao) context.getBean("cardDao");
	}
	
	public static RoomDao getRoomDao(){
		return (RoomDao) context.getBean("roomDao");
	}
	
	public static RoomTypeDao getRoomTypeDao() {
		return (RoomTypeDao) context.getBean("roomTypeDao");
	}
	
	public static BoardDao getBoardDao(){
		return (BoardDao) context.getBean("boardDao");
	}
	
	public static PriceTypeDao getPriceTypeDao(){
		return (PriceTypeDao) context.getBean("priceTypeDao");
	}
	
	public static SeasonDao getSeasonDao() {
		return (SeasonDao) context.getBean("seasonDao");
	}
	
	public static ConceptDao getConceptDao(){
		return (ConceptDao) context.getBean("conceptDao");
	}
	
	public static ClientDao getAgencyDao() {
		return (ClientDao) context.getBean("agencyDao");
	}
	
	public static ClientDao getCompanyDao() {
		return (ClientDao) context.getBean("companyDao");
	}
	
	public static ClientDao getParticularDao() {
		return (ClientDao) context.getBean("particularDao");
	}
	
	public static DayDao getDayDao() {
		return (DayDao) context.getBean("dayDao");
	}
	
	public static EmployeeDao getEmployeeDao() {
		return (EmployeeDao) context.getBean("employeeDao");
	}
	
	public static UserDao getUserDao() {
		return (UserDao) context.getBean("userDao");
	}
	
	public static RoleDao getRoleDao() {
		return (RoleDao) context.getBean("roleDao");
	}
	
	public static ReservationDao getReservationDao() {
		return (ReservationDao) context.getBean("reservationDao");
	}
	
	public static RequestDao getRequestDao() {
		return (RequestDao) context.getBean("requestDao");
	}
	
	public static OweDao getOweDao() {
		return (OweDao) context.getBean("oweDao");
	}
	
	public static PriceDao getPriceDao() {
		return (PriceDao) context.getBean("priceDao");
	}
	
	public static InvoiceDao getInvoiceDao() {
		return (InvoiceDao) context.getBean("invoiceDao");
	}
	
	public static WashDao getWashDao() {
		return (WashDao) context.getBean("washDao");
	}
	
}
