package gz.cyberbrain.cyberhotel.view.swing.edit;

import gz.cyberbrain.cyberhotel.controller.AddressController;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.security.SecurityHandler;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JPanel;
import javax.swing.JList;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;

import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.text.Position;

public class AddressWindow extends JInternalFrame {

	private static final long serialVersionUID = 1L;

	private static AddressWindow addressWindow = null;

	private JPanel jContentPane = null;

	private JList countriesList = null;

	private JList provincesList = null;

	private JList localitiesList = null;

	private JLabel countriesLabel = null;

	private JLabel provincesLabel = null;

	private JLabel localitiesLabel = null;

	private JLabel addCountryLabel = null;

	private JLabel delCountryLabel = null;

	private JLabel addProvinceLabel = null;

	private JLabel delProvinceLabel = null;

	private JLabel addLocalityLabel = null;

	private JLabel delLocalityLabel = null;

	private InfoPanel infoPanel = null;

	private JScrollPane countriesScrollPane = null;

	private JScrollPane provincesScrollPane = null;

	private JScrollPane localitiesScrollPane = null;

	private JTextField searchCountryTextField = null;

	private JButton searchCountryButton = null;

	private JTextField searchProvinceTextField = null;

	private JTextField searchLocalityTextField = null;

	private JButton searchProvinceButton = null;

	private JButton searchLocalityButton = null;

	private JTextField addCountryTextField = null;

	private JTextField addProvinceTextField = null;

	private JTextField addLocalityTextField = null;

	/**
	 * This is the default constructor
	 */
	private AddressWindow() {
		super("", false, true, false, true);
		initialize();
	}

	public static AddressWindow getInstance() {
		if (addressWindow == null) addressWindow = new AddressWindow();
		return addressWindow;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {

		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension dim = toolkit.getScreenSize();

		this.setSize(612, 459);
		this.setMaximumSize(new Dimension(612, 459));		

		this.setLocation(dim.width/2 - getWidth()/2, 
				dim.height/2 - getHeight()/2);

		//this.setLocation(dim.width-800,dim.height-600);
		this.setResizable(false);

		this.setContentPane(getJContentPane());				 
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{   

			public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt)
			{        
				addressWindow = null;
			}
		});	

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {

			localitiesLabel = new JLabel();
			localitiesLabel.setBounds(new Rectangle(456, 55, 79, 16));
			localitiesLabel.setText("<html><font> <b>" + Locale.get("AddressWindow.localitiesLabel") + "</b></font></html>");
			localitiesLabel.setForeground(Color.BLACK);
			provincesLabel = new JLabel();
			provincesLabel.setBounds(new Rectangle(266, 55, 78, 16));
			provincesLabel.setText("<html><font> <b>" + Locale.get("AddressWindow.provincesLabel") + "</b></font></html>");
			provincesLabel.setForeground(Color.BLACK);
			countriesLabel = new JLabel();
			countriesLabel.setBounds(new Rectangle(85, 55, 45, 16));
			countriesLabel.setText("<html><font> <b>" + Locale.get("AddressWindow.countriesLabel") + "</b></font></html>");
			countriesLabel.setForeground(Color.BLACK);
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getInfoPanel());
			jContentPane.add(getCountriesList(), null);
			jContentPane.add(getProvincesList(), null);
			jContentPane.add(getLocalitiesList(), null);
			jContentPane.add(countriesLabel, null);
			jContentPane.add(provincesLabel, null);
			jContentPane.add(localitiesLabel, null);
			jContentPane.add(getAddCountryLabel(), null);
			jContentPane.add(getDelCountryLabel(), null);
			jContentPane.add(getAddProvinceLabel(), null);
			jContentPane.add(getDelProvinceLabel(), null);
			jContentPane.add(getAddLocalityLabel(), null);
			jContentPane.add(getDelLocalityLabel(), null);
			jContentPane.add(getCountriesScrollPane(), null);
			jContentPane.add(getProvincesScrollPane(), null);
			jContentPane.add(getLocalitiesScrollPane(), null);
			jContentPane.add(getSearchCountryTextField(), null);
			jContentPane.add(getSearchCountryButton(), null);
			jContentPane.add(getSearchProvinceTextField(), null);
			jContentPane.add(getSearchLocalityTextField(), null);
			jContentPane.add(getSearchProvinceButton(), null);
			jContentPane.add(getSearchLocalityButton(), null);
			jContentPane.add(getAddCountryTextField(), null);
			jContentPane.add(getAddProvinceTextField(), null);
			jContentPane.add(getAddLocalityTextField(), null);
		}
		return jContentPane;
	}

	private InfoPanel getInfoPanel() {

		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);		
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {
		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);
	}

	/**
	 * This method initializes countriesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getCountriesList() {
		if (countriesList == null) {
			countriesList = new JList();

			SecurityHandler.setSecureContext("admin", "admin");
			countriesList.setListData(AddressController.countriesList().toArray());
			countriesList.setSelectedIndex(0);
			countriesList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
			{
				public void valueChanged(javax.swing.event.ListSelectionEvent evt)
				{

					getProvincesList().setListData(AddressController.countryProvincesList((String)countriesList.getSelectedValue()).toArray());
					getProvincesList().setSelectedIndex(0);


				}
			});

		}
		return countriesList;
	}

	/**
	 * This method initializes provincesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getProvincesList() {
		if (provincesList == null) {
			provincesList = new JList();

			SecurityHandler.setSecureContext("admin", "admin");
			provincesList.setListData(AddressController.countryProvincesList((String)countriesList.getSelectedValue()).toArray());
			provincesList.setSelectedIndex(0);
			provincesList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
			{
				public void valueChanged(javax.swing.event.ListSelectionEvent evt)
				{

					getLocalitiesList().setListData(AddressController.provinceLocalitiesList((String) countriesList.getSelectedValue(), (String)provincesList.getSelectedValue()).toArray());
					getLocalitiesList().setSelectedIndex(0);


				}
			});

		}
		return provincesList;
	}

	/**
	 * This method initializes localitiesList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getLocalitiesList() {
		if (localitiesList == null) {
			localitiesList = new JList();			

			localitiesList.setListData(AddressController.provinceLocalitiesList((String)countriesList.getSelectedValue(), (String)provincesList.getSelectedValue()).toArray());
			localitiesList.setSelectedIndex(0);				

		}
		return localitiesList;
	}

	private JLabel getDelLocalityLabel() {

		if (delLocalityLabel == null) {

			delLocalityLabel = new JLabel();			
			delLocalityLabel.setBounds(new Rectangle(507, 397, 53, 16));
			delLocalityLabel.setText("<html> <u>" + Locale.get("AddressWindow.delLabel") + "</u> </html>");
			delLocalityLabel.setForeground(Color.BLUE);
			delLocalityLabel.addMouseListener(new MouseAdapter() {

				public void mouseClicked(MouseEvent ae){

					if (getCountriesList().getSelectedValue() != null) {

						Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
						int n = JOptionPane.showOptionDialog(AddressWindow.getInstance(),
								Locale.get("JOptionPane.AddressWindow.delLocalityLabel.question"),
								Locale.get("JOptionPane.AddressWindow.delLocalityLabel.title"),
								JOptionPane.YES_NO_OPTION,
								JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);

						if (n == JOptionPane.YES_OPTION) {


							AddressController.removeByLocality((String) getCountriesList().getSelectedValue(), (String) getProvincesList().getSelectedValue(), (String) getLocalitiesList().getSelectedValue());
							getLocalitiesList().setListData(AddressController.provinceLocalitiesList((String)countriesList.getSelectedValue(), (String) getProvincesList().getSelectedValue()).toArray());
							getLocalitiesList().setSelectedIndex(0);


						}

						showErrors();

					}

				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					delLocalityLabel.setForeground(Color.RED);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					delLocalityLabel.setForeground(Color.BLUE);
				}
			});

		}

		return delLocalityLabel;

	}

	private JLabel getAddLocalityLabel() {

		if (addLocalityLabel == null) {

			addLocalityLabel = new JLabel();
			addLocalityLabel.setBounds(new Rectangle(434, 397, 53, 16));
			addLocalityLabel.setText("<html> <u>" + Locale.get("AddressWindow.addLabel") + "</u> </html>");
			addLocalityLabel.setForeground(Color.BLUE);
			addLocalityLabel.addMouseListener(new MouseAdapter() {				

				public void mousePressed(MouseEvent p0){

					if (getProvincesList().getSelectedValue() != null){

						getAddCountryTextField().setEnabled(false);
						getAddProvinceTextField().setEnabled(false);
						getAddCountryTextField().setBackground(Color.LIGHT_GRAY);
						getAddProvinceTextField().setBackground(Color.LIGHT_GRAY);
						getAddCountryTextField().setText("");
						getAddProvinceTextField().setText("");										
						getAddLocalityTextField().setEnabled(true);
						getAddLocalityTextField().setBackground(Color.BLACK);
						getAddLocalityTextField().setForeground(Color.GREEN);
						getAddLocalityTextField().requestFocusInWindow();
					}
				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					addLocalityLabel.setForeground(Color.GREEN);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					addLocalityLabel.setForeground(Color.BLUE);
				}
			});

		}
		return addLocalityLabel;

	}

	private JLabel getDelProvinceLabel() {

		if (delProvinceLabel == null) {

			delProvinceLabel = new JLabel();
			delProvinceLabel.setBounds(new Rectangle(312, 397, 53, 16));
			delProvinceLabel.setText("<html> <u>" + Locale.get("AddressWindow.delLabel") + "</u> </html>");
			delProvinceLabel.setForeground(Color.BLUE);
			delProvinceLabel.addMouseListener(new MouseAdapter() {

				public void mouseClicked(MouseEvent ae){

					if (getCountriesList().getSelectedValue() != null) {

						Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
						int n = JOptionPane.showOptionDialog(AddressWindow.getInstance(),
								Locale.get("JOptionPane.AddressWindow.delProvinceLabel.question"),
								Locale.get("JOptionPane.AddressWindow.delProvinceLabel.title"),
								JOptionPane.YES_NO_OPTION,
								JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);

						if (n == JOptionPane.YES_OPTION) {


							AddressController.removeByProvince((String) getCountriesList().getSelectedValue(), (String) getProvincesList().getSelectedValue());
							getProvincesList().setListData(AddressController.countryProvincesList((String) getCountriesList().getSelectedValue()).toArray());
							getProvincesList().setSelectedIndex(0);

						}

						showErrors();

					}

				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					delProvinceLabel.setForeground(Color.RED);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					delProvinceLabel.setForeground(Color.BLUE);
				}
			});

		}

		return delProvinceLabel;

	}

	private JLabel getAddProvinceLabel() {

		if (addProvinceLabel == null) {

			addProvinceLabel = new JLabel();
			addProvinceLabel.setBounds(new Rectangle(241, 397, 53, 16));
			addProvinceLabel.setText("<html> <u>" + Locale.get("AddressWindow.addLabel") + "</u> </html>");
			addProvinceLabel.setForeground(Color.BLUE);
			addProvinceLabel.addMouseListener(new MouseAdapter() {

				public void mousePressed(MouseEvent p0){

					if (getCountriesList().getSelectedValue() != null) {

						getAddCountryTextField().setEnabled(false);
						getAddLocalityTextField().setEnabled(false);
						getAddCountryTextField().setBackground(Color.LIGHT_GRAY);
						getAddLocalityTextField().setBackground(Color.LIGHT_GRAY);
						getAddCountryTextField().setText("");
						getAddLocalityTextField().setText("");
						getAddProvinceTextField().setEnabled(true);
						getAddProvinceTextField().setBackground(Color.BLACK);
						getAddProvinceTextField().setForeground(Color.GREEN);
						getAddProvinceTextField().requestFocusInWindow();

					}
				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					addProvinceLabel.setForeground(Color.GREEN);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					addProvinceLabel.setForeground(Color.BLUE);
				}
			});

		}
		return addProvinceLabel;
	}

	private JLabel getDelCountryLabel() {

		if (delCountryLabel == null) {
			delCountryLabel = new JLabel();
			delCountryLabel.setBounds(new Rectangle(114, 397, 53, 16));
			delCountryLabel.setText("<html> <u>" + Locale.get("AddressWindow.delLabel") + "</u> </html>");
			delCountryLabel.setForeground(Color.BLUE);
			delCountryLabel.addMouseListener(new MouseAdapter() {

				public void mouseClicked(MouseEvent ae){

					if (getCountriesList().getSelectedValue() != null) {

						Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
						int n = JOptionPane.showOptionDialog(AddressWindow.getInstance(),
								Locale.get("JOptionPane.AddressWindow.delCountryLabel.question"),
								Locale.get("JOptionPane.AddressWindow.delCountryLabel.title"),
								JOptionPane.YES_NO_OPTION,
								JOptionPane.QUESTION_MESSAGE,
								null,
								options,
								options[1]);

						if (n == JOptionPane.YES_OPTION) {


							AddressController.removeByCountry((String) getCountriesList().getSelectedValue());
							getCountriesList().setListData(AddressController.countriesList().toArray());
							getCountriesList().setSelectedIndex(0);


						}

						showErrors();

					}

				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					delCountryLabel.setForeground(Color.RED);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					delCountryLabel.setForeground(Color.BLUE);
				}
			});

		}
		return delCountryLabel;
	}

	private JLabel getAddCountryLabel() {

		if(addCountryLabel==null) {

			addCountryLabel = new JLabel();
			addCountryLabel.setBounds(new Rectangle(45, 397, 53, 16));
			addCountryLabel.setText("<html> <u>" + Locale.get("AddressWindow.addLabel") + "</u> </html>");
			addCountryLabel.setForeground(Color.BLUE);	
			addCountryLabel.addMouseListener(new MouseAdapter() {

				public void mousePressed(MouseEvent p0){					

					getAddProvinceTextField().setEnabled(false);
					getAddLocalityTextField().setEnabled(false);
					getAddProvinceTextField().setBackground(Color.LIGHT_GRAY);
					getAddLocalityTextField().setBackground(Color.LIGHT_GRAY);
					getAddProvinceTextField().setText("");
					getAddLocalityTextField().setText("");
					getAddCountryTextField().setEnabled(true);
					getAddCountryTextField().setBackground(Color.BLACK);
					getAddCountryTextField().setForeground(Color.GREEN);
					getAddCountryTextField().requestFocusInWindow();					

				}

				public void mouseEntered(MouseEvent p0)
				{					
					setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
					addCountryLabel.setForeground(Color.GREEN);
				}

				public void mouseExited(MouseEvent p0)
				{					
					setCursor(Cursor.getDefaultCursor());
					addCountryLabel.setForeground(Color.BLUE);
				}
			});

		}
		return addCountryLabel;
	}

	/**
	 * This method initializes countriesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getCountriesScrollPane() {
		if (countriesScrollPane == null) {
			countriesScrollPane = new JScrollPane();
			countriesScrollPane.setBounds(new Rectangle(35, 105, 145, 236));
			countriesScrollPane.setViewportView(getCountriesList());
		}
		return countriesScrollPane;
	}

	/**
	 * This method initializes provincesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getProvincesScrollPane() {
		if (provincesScrollPane == null) {
			provincesScrollPane = new JScrollPane();
			provincesScrollPane.setBounds(new Rectangle(229, 105, 145, 235));
			provincesScrollPane.setViewportView(getProvincesList());
		}
		return provincesScrollPane;
	}

	/**
	 * This method initializes localitiesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getLocalitiesScrollPane() {
		if (localitiesScrollPane == null) {
			localitiesScrollPane = new JScrollPane();
			localitiesScrollPane.setBounds(new Rectangle(423, 105, 145, 238));
			localitiesScrollPane.setViewportView(getLocalitiesList());
		}
		return localitiesScrollPane;
	}

	/**
	 * This method initializes searchCountryTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSearchCountryTextField() {
		if (searchCountryTextField == null) {
			searchCountryTextField = new JTextField();
			searchCountryTextField.setBounds(new Rectangle(36, 79, 112, 19));
			searchCountryTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyPressed(java.awt.event.KeyEvent e) {

					String text = searchCountryTextField.getText(); 

					try {

						if (e.getKeyCode() == KeyEvent.VK_BACK_SPACE && text.length() != 0) 
							getCountriesList().setSelectedIndex(getCountriesList().getNextMatch(text.substring(0,text.length() - 1), 0, Position.Bias.Forward));
						else getCountriesList().setSelectedIndex(getCountriesList().getNextMatch(text + e.getKeyChar(), 0, Position.Bias.Forward));

					} catch (IllegalArgumentException f){}

				}
			});
		}
		return searchCountryTextField;
	}

	/**
	 * This method initializes searchCountryButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchCountryButton() {
		if (searchCountryButton == null) {
			searchCountryButton = new JButton();
			searchCountryButton.setBounds(new Rectangle(158, 79, 21, 19));
		}
		return searchCountryButton;
	}

	/**
	 * This method initializes searchProvinceTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSearchProvinceTextField() {
		if (searchProvinceTextField == null) {
			searchProvinceTextField = new JTextField();
			searchProvinceTextField.setBounds(new Rectangle(230, 79, 112, 20));
			searchProvinceTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyPressed(java.awt.event.KeyEvent e) {

					String text = searchProvinceTextField.getText(); 

					try {

						if (e.getKeyCode() == KeyEvent.VK_BACK_SPACE && text.length() != 0) getProvincesList().setSelectedIndex(getProvincesList().getNextMatch(text.substring(0,text.length() - 1), 0, Position.Bias.Forward));
						else getProvincesList().setSelectedIndex(getProvincesList().getNextMatch(text + e.getKeyChar(), 0, Position.Bias.Forward));

					} catch (IllegalArgumentException f) {} 

				}
			});
		}
		return searchProvinceTextField;
	}

	/**
	 * This method initializes searchLocalityTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSearchLocalityTextField() {
		if (searchLocalityTextField == null) {
			searchLocalityTextField = new JTextField();
			searchLocalityTextField.setBounds(new Rectangle(423, 79, 112, 20));
			searchLocalityTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyPressed(java.awt.event.KeyEvent e) {

					String text = searchLocalityTextField.getText(); 

					try {

						if (e.getKeyCode() == KeyEvent.VK_BACK_SPACE && text.length() != 0) getLocalitiesList().setSelectedIndex(getLocalitiesList().getNextMatch(text.substring(0,text.length() - 1), 0, Position.Bias.Forward));
						else getLocalitiesList().setSelectedIndex(getLocalitiesList().getNextMatch(text + e.getKeyChar(), 0, Position.Bias.Forward));

					} catch (IllegalArgumentException f) {}

				}
			});
		}
		return searchLocalityTextField;
	}

	/**
	 * This method initializes searchProvinceButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchProvinceButton() {
		if (searchProvinceButton == null) {
			searchProvinceButton = new JButton();
			searchProvinceButton.setBounds(new Rectangle(352, 79, 21, 19));
		}
		return searchProvinceButton;
	}

	/**
	 * This method initializes searchLocalityButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchLocalityButton() {
		if (searchLocalityButton == null) {
			searchLocalityButton = new JButton();
			searchLocalityButton.setBounds(new Rectangle(546, 79, 21, 19));
		}
		return searchLocalityButton;
	}

	/**
	 * This method initializes addCountryTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAddCountryTextField() {
		if (addCountryTextField == null) {
			addCountryTextField = new JTextField();
			addCountryTextField.setBounds(new Rectangle(36, 366, 143, 19));
			addCountryTextField.setEnabled(false);			
			addCountryTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				@SuppressWarnings("unchecked")
				public void keyPressed(java.awt.event.KeyEvent e) {

					if (e.getKeyCode() == KeyEvent.VK_ENTER && !(getAddCountryTextField().getText()).equals("")) {

						Collection countries = AddressController.countriesList(); 
						ArrayList iter = new ArrayList (countries);

						for (int i=0; i<iter.size(); i++) iter.set(i, ((String)iter.get(i)).toUpperCase());

						if(iter.contains(getAddCountryTextField().getText().toUpperCase())) {
							getCountriesList().setSelectedIndex(getCountriesList().getNextMatch((String) getAddCountryTextField().getText(), 0, Position.Bias.Forward));
							addCountryTextField.setText("");
						} else {															
							AddressController.createAddress(getAddCountryTextField().getText(), "", "");
							getCountriesList().setListData(AddressController.countriesList().toArray());
							getCountriesList().setSelectedIndex(getCountriesList().getNextMatch((String) getAddCountryTextField().getText(), 0, Position.Bias.Forward));
							addCountryTextField.setText("");
						}

					}	

				}
			});

			addCountryTextField.addFocusListener(new java.awt.event.FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent e) {
					addCountryTextField.setBackground(Color.LIGHT_GRAY);
					addCountryTextField.setText("");
					addCountryTextField.setEnabled(false);
				}
			});
		}
		return addCountryTextField;
	}

	/**
	 * This method initializes addProvinceTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAddProvinceTextField() {
		if (addProvinceTextField == null) {
			addProvinceTextField = new JTextField();
			addProvinceTextField.setBounds(new Rectangle(231, 366, 143, 19));
			addProvinceTextField.setEnabled(false);
			addProvinceTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				@SuppressWarnings("unchecked")
				public void keyPressed(java.awt.event.KeyEvent e) {	

					if (e.getKeyCode() == KeyEvent.VK_ENTER && !(getAddProvinceTextField().getText()).equals("")) {

						Collection provinces = AddressController.countryProvincesList((String)getCountriesList().getSelectedValue()); 
						ArrayList iter = new ArrayList (provinces);

						for (int i=0; i<iter.size(); i++) iter.set(i, ((String)iter.get(i)).toUpperCase());

						if(iter.contains(getAddProvinceTextField().getText().toUpperCase())) {
							getProvincesList().setSelectedIndex(getProvincesList().getNextMatch((String) getAddProvinceTextField().getText(), 0, Position.Bias.Forward));
							addProvinceTextField.setText("");
						} else {																								
							AddressController.createAddress((String)getCountriesList().getSelectedValue(), getAddProvinceTextField().getText(), "");
							getProvincesList().setListData(AddressController.countryProvincesList((String)getCountriesList().getSelectedValue()).toArray());
							getProvincesList().setSelectedIndex(getProvincesList().getNextMatch((String) getAddProvinceTextField().getText(), 0, Position.Bias.Forward));
							addProvinceTextField.setText("");
						}

					}	

				}
			});

			addProvinceTextField.addFocusListener(new java.awt.event.FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent e) {
					addProvinceTextField.setBackground(Color.LIGHT_GRAY);
					addProvinceTextField.setText("");
					addProvinceTextField.setEnabled(false);					
				}
			});

		}
		return addProvinceTextField;
	}

	/**
	 * This method initializes addLocalityTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAddLocalityTextField() {
		if (addLocalityTextField == null) {
			addLocalityTextField = new JTextField();
			addLocalityTextField.setBounds(new Rectangle(426, 366, 143, 19));
			addLocalityTextField.setEnabled(false);
			addLocalityTextField.addKeyListener(new java.awt.event.KeyAdapter() {
				@SuppressWarnings("unchecked")
				public void keyPressed(java.awt.event.KeyEvent e) {

					if (e.getKeyCode() == KeyEvent.VK_ENTER && !(getAddLocalityTextField().getText()).equals("")) {

						Collection localities = AddressController.provinceLocalitiesList((String)countriesList.getSelectedValue(), (String)getProvincesList().getSelectedValue()); 
						ArrayList iter = new ArrayList (localities);

						for (int i=0; i<iter.size(); i++) iter.set(i, ((String)iter.get(i)).toUpperCase());

						if(iter.contains(getAddLocalityTextField().getText().toUpperCase())) {
							getLocalitiesList().setSelectedIndex(getLocalitiesList().getNextMatch((String) getAddLocalityTextField().getText(), 0, Position.Bias.Forward));
							addLocalityTextField.setText("");
						} else {							
							AddressController.createAddress((String)getCountriesList().getSelectedValue(), (String)getProvincesList().getSelectedValue(), getAddLocalityTextField().getText());
							getLocalitiesList().setListData(AddressController.provinceLocalitiesList((String)countriesList.getSelectedValue(), (String)getProvincesList().getSelectedValue()).toArray());
							getLocalitiesList().setSelectedIndex(getLocalitiesList().getNextMatch((String) getAddLocalityTextField().getText(), 0, Position.Bias.Forward));
							addLocalityTextField.setText("");
						}

					}	

				}
			});

			addLocalityTextField.addFocusListener(new java.awt.event.FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent e) {
					addLocalityTextField.setBackground(Color.LIGHT_GRAY);
					addLocalityTextField.setText("");
					addLocalityTextField.setEnabled(false);
				}
			});

		}
		return addLocalityTextField;
	}

	private void showErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("delete")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AddressWindow.errors.delete")+ "</html>");							
				Toolkit.getDefaultToolkit().beep();
				ErrorsHandler.clear();
			}			

		}  else getInfoPanel().setInfoText(getInfoPanel().getInfoText());

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
