package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/* ImageFileView.java is used by FileChooserDemo2.java. */
public class ImageFileView extends FileView {
	
	private static String location = ClassLoader.getSystemResource(".").getPath();
	
	static {
		location = location.replace("%20", " "); //URL converts blankspaces into %20
	}
	ImageIcon jpgIcon = ImageUtils.createImageIcon(location + "gz/cyberbrain/cyberhotel/view/swing/images/jpgIcon.gif");
	ImageIcon gifIcon = ImageUtils.createImageIcon(location + "gz/cyberbrain/cyberhotel/view/swing/images/gifIcon.gif");
	ImageIcon tiffIcon = ImageUtils.createImageIcon(location + "gz/cyberbrain/cyberhotel/view/swing/images/tiffIcon.gif");
	ImageIcon pngIcon = ImageUtils.createImageIcon(location + "gz/cyberbrain/cyberhotel/view/swing/images/pngIcon.png");

	public String getName(File f) {
		return null; //let the L&F FileView figure this out
	}

	public String getDescription(File f) {
		return null; //let the L&F FileView figure this out
	}

	public Boolean isTraversable(File f) {
		return null; //let the L&F FileView figure this out
	}

	public String getTypeDescription(File f) {
		String extension = ImageUtils.getExtension(f);
		String type = null;

		if (extension != null) {
			if (extension.equals(ImageUtils.jpeg) ||
					extension.equals(ImageUtils.jpg)) {
				type = "JPEG Image";
			} else if (extension.equals(ImageUtils.gif)){
				type = "GIF Image";
			} else if (extension.equals(ImageUtils.tiff) ||
					extension.equals(ImageUtils.tif)) {
				type = "TIFF Image";
			} else if (extension.equals(ImageUtils.png)){
				type = "PNG Image";
			}
		}
		return type;
	}

	public Icon getIcon(File f) {
		String extension = ImageUtils.getExtension(f);
		Icon icon = null;

		if (extension != null) {
			if (extension.equals(ImageUtils.jpeg) ||
					extension.equals(ImageUtils.jpg)) {
				icon = jpgIcon;
			} else if (extension.equals(ImageUtils.gif)) {
				icon = gifIcon;
			} else if (extension.equals(ImageUtils.tiff) ||
					extension.equals(ImageUtils.tif)) {
				icon = tiffIcon;
			} else if (extension.equals(ImageUtils.png)) {
				icon = pngIcon;
			}
		}
		return icon;
	}
}
