package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.awt.FlowLayout;
import java.awt.Image;
import java.io.Serializable;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ImageItem extends JPanel implements ListItem {

	private static final long serialVersionUID = 1L;
	private Serializable id;
	private String text;

	public ImageItem(Serializable id, String text, String imagePath) {

		this.id = id;
		this.text = text;
		setLayout(new FlowLayout(FlowLayout.LEFT));
		add(new JLabel(resizeImage(new ImageIcon(imagePath))));
		add(new JLabel(text));

	}

	public Serializable getId() {
		return id;
	}
	
	public String getText() {
		return text;
	}

	public void setId(Serializable id) {
		this.id = id;
	}

	public void setText(String text) {
		this.text = text;
	}

	private ImageIcon resizeImage(ImageIcon tmpIcon) {

		ImageIcon thumbnail = tmpIcon;

		if (tmpIcon.getIconHeight() > 50) {
			thumbnail = new ImageIcon(tmpIcon.getImage().
					getScaledInstance(70, 50,
							Image.SCALE_DEFAULT));
		}

		return thumbnail;
	}
	
	public String toString() {
		return text;
	}
	
}
